/*
 * Copyright (C) 2010  Axel Kesseler
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */
#pragma once

namespace plexdata
{
	namespace version
	{
		class CVersionInfo
		{

		private:

			TCHAR* m_szFileVersionRoot;
			TCHAR* m_szProductVersionRoot;
			TCHAR* m_szComments; 
			TCHAR* m_szInternalName; 
			TCHAR* m_szProductName; 
			TCHAR* m_szCompanyName; 
			TCHAR* m_szLegalCopyright; 
			TCHAR* m_szProductVersion; 
			TCHAR* m_szFileDescription; 
			TCHAR* m_szLegalTrademarks; 
			TCHAR* m_szPrivateBuild; 
			TCHAR* m_szFileVersion; 
			TCHAR* m_szOriginalFilename; 
			TCHAR* m_szSpecialBuild; 

		public:

			CVersionInfo();

			virtual ~CVersionInfo();

			void Initialize( const TCHAR* szFilename );

		public:

			inline TCHAR* Comments()
			{
				return this->m_szComments;
			}

			inline TCHAR* InternalName()
			{
				return this->m_szInternalName;
			}

			inline TCHAR* ProductName()
			{
				return this->m_szProductName;
			}

			inline TCHAR* CompanyName()
			{
				return this->m_szCompanyName;
			}

			inline TCHAR* LegalCopyright()
			{
				return this->m_szLegalCopyright;
			}

			inline TCHAR* ProductVersion( bool bRoot = true )
			{
				if ( bRoot )
				{
					return this->m_szProductVersionRoot;
				}
				else
				{
					return this->m_szProductVersion;
				}
			}

			inline TCHAR* FileDescription()
			{
				return this->m_szFileDescription;
			}

			inline TCHAR* LegalTrademarks()
			{
				return this->m_szLegalTrademarks;
			}

			inline TCHAR* PrivateBuild()
			{
				return this->m_szPrivateBuild;
			}

			inline TCHAR* FileVersion( bool bRoot = true )
			{
				if ( bRoot )
				{
				return this->m_szFileVersionRoot;
				}
				else
				{
				return this->m_szFileVersion;
				}
			}

			inline TCHAR* OriginalFilename()
			{
				return this->m_szOriginalFilename;
			}

			inline TCHAR* SpecialBuild()
			{
				return this->m_szSpecialBuild;
			}

		private:

			void GetRootInformation
				( void* pBuffer 
				);

			bool GetLanguageID
				( void*  pBuffer
				, TCHAR* szResult
				, int    nResult 
				);

			void GetStringValue
				( void*   pBuffer
				, TCHAR*  szLangID
				, TCHAR*  szValue
				, TCHAR** ppResult 
				);
		};
	}
}